﻿using Syncfusion.Windows.Diagram;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Symbolpalette_135618
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            SymbolPaletteGroup s = new SymbolPaletteGroup();
            s.Label = "Custom";
            SymbolPalette.SetFilterIndexes(s, new Int32Collection(new int[] { 0, 1 }));
            diagram.SymbolPalette.SymbolGroups.Add(s);
            Node n = new Node();
            n.Width = 100;
            n.Height = 100;           
            n.OffsetX = 100;
            n.OffsetY = 100;        
            Image img = new Image();
            img.Width = 100;
            img.Height =85;
            img.Stretch = Stretch.Fill;
            img.Source = new BitmapImage(new Uri(@"pack://application:,,,/Symbolpalette_135618;component/baby.jpg"));
            TextBlock txt = new TextBlock();
            txt.Text = "welcome";
            StackPanel stackPnl = new StackPanel();
            stackPnl.Children.Add(img);
            stackPnl.Children.Add(txt);
            n.Content = stackPnl;
            n.AllowRotate = true;
            AddPort(0, 50,n);
            AddPort(50, 0,n);
            AddPort(100, 50,n);
            AddPort(50, 100,n);
            n.IsHitTestVisible = false;
            SymbolPaletteItem item = new SymbolPaletteItem();
            item.Content = n;
            //adding node to the symbolpalette 
            s.Items.Add(item);

            Node n2 = new Node();
            n2.Width = 100;
            n2.Height = 100;
            n2.OffsetX = 100;
            n2.OffsetY = 100;
            Image img2 = new Image();
            img2.Width = 100;
            img2.Height = 85;
            img2.Stretch = Stretch.Fill;
            img2.Source = new BitmapImage(new Uri(@"pack://application:,,,/Symbolpalette_135618;component/baby.jpg"));
            TextBlock txt2 = new TextBlock();
            txt2.Text = "welcome";
            StackPanel stackPnl2 = new StackPanel();
            stackPnl2.Children.Add(img2);
            stackPnl2.Children.Add(txt2);
            n2.Content = stackPnl2;
            n2.AllowRotate = true;
            AddPort(0, 50, n2);
            AddPort(50, 0, n2);
            AddPort(100, 50, n2);
            AddPort(50, 100, n2);
            n2.IsHitTestVisible = true;         
            diagram.Model.Nodes.Add(n2);

        }
        //adding ports
        private void AddPort(int p1, int p2,Node n)
        {
            ConnectionPort port = new ConnectionPort();
            port.Width = 20;
            port.Height = 20;
            port.Left = p1; 
            port.Top = p2;
            port.PortStyle.Stroke = new SolidColorBrush(Colors.Brown);
            port.PortStyle.Fill = new SolidColorBrush(Colors.Yellow);
            port.PortStyle.StrokeThickness = 3d;
            port.Node = n;
            n.PortVisibility = PortVisibility.AlwaysVisible;
            n.Ports.Add(port);
        }
    }
}
